Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Operation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Operation.cpp	(revision 75)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Operation.cpp	(revision 76)
@@ -52,5 +52,5 @@
 
     // Result
-    op->_timing       = param->_timing[op->_operation];
+    op->_timing       = param->_timing[op->_type][op->_operation];
     op->_data_rd      = gpr3;
     op->_data_re      = 0;
@@ -78,5 +78,5 @@
 
     // Result
-    op->_timing       = param->_timing[op->_operation];
+    op->_timing       = param->_timing[op->_type][op->_operation];
     op->_data_rd      = gpr3;
     op->_data_re      = 0;
@@ -102,5 +102,5 @@
 
     // Result
-    op->_timing       = param->_timing[op->_operation];
+    op->_timing       = param->_timing[op->_type][op->_operation];
     op->_data_rd      = gpr3;
     op->_data_re      = 0;
@@ -123,5 +123,5 @@
 
     // Result
-    op->_timing       = param->_timing[op->_operation];
+    op->_timing       = param->_timing[op->_type][op->_operation];
     op->_data_rd      = gpr3;
   //op->_data_re      = 0;
@@ -142,5 +142,5 @@
 
     // Result
-    op->_timing       = param->_timing[op->_operation];
+    op->_timing       = param->_timing[op->_type][op->_operation];
     op->_data_rd      = gpr3;
   //op->_data_re      = 0;
@@ -161,5 +161,5 @@
 
     // Result
-    op->_timing       = param->_timing[op->_operation];
+    op->_timing       = param->_timing[op->_type][op->_operation];
     op->_data_rd      = gpr3;
   //op->_data_re      = 0;
@@ -179,5 +179,5 @@
 
     // Result
-    op->_timing       = param->_timing[op->_operation];
+    op->_timing       = param->_timing[op->_type][op->_operation];
     op->_data_rd      = gpr2;
   //op->_data_re      = 0;
@@ -200,5 +200,5 @@
 
     // Result
-    op->_timing       = param->_timing[op->_operation];
+    op->_timing       = param->_timing[op->_type][op->_operation];
     op->_data_rd      = gpr3;
   //op->_data_re      = 0;
@@ -218,5 +218,5 @@
 
     // Result
-    op->_timing       = param->_timing[op->_operation];
+    op->_timing       = param->_timing[op->_type][op->_operation];
   //op->_data_rd      = 0;
   //op->_data_re      = 0;
@@ -236,5 +236,5 @@
 
     // Result
-    op->_timing       = param->_timing[op->_operation];
+    op->_timing       = param->_timing[op->_type][op->_operation];
   //op->_data_rd      = 0;
   //op->_data_re      = 0;
@@ -258,5 +258,5 @@
 
     // Result
-    op->_timing       = param->_timing[op->_operation];
+    op->_timing       = param->_timing[op->_type][op->_operation];
     op->_data_rd      = imm;
   //op->_data_re      = 0;
@@ -277,5 +277,5 @@
 
     // Result
-    op->_timing       = param->_timing[op->_operation];
+    op->_timing       = param->_timing[op->_type][op->_operation];
     op->_data_rd      = gpr2;
   //op->_data_re      = 0;
@@ -296,5 +296,5 @@
 
     // Result
-    op->_timing       = param->_timing[op->_operation];
+    op->_timing       = param->_timing[op->_type][op->_operation];
     op->_data_rd      = gpr2;
   //op->_data_re      = 0;
@@ -315,5 +315,5 @@
 
     // Result
-    op->_timing       = param->_timing[op->_operation];
+    op->_timing       = param->_timing[op->_type][op->_operation];
     op->_data_rd      = gpr3;
   //op->_data_re      = 0;
@@ -334,5 +334,5 @@
 
     // Result
-    op->_timing       = param->_timing[op->_operation];
+    op->_timing       = param->_timing[op->_type][op->_operation];
     op->_data_rd      = gpr3;
   //op->_data_re      = 0;
@@ -353,5 +353,5 @@
 
     // Result
-    op->_timing       = param->_timing[op->_operation];
+    op->_timing       = param->_timing[op->_type][op->_operation];
     op->_data_rd      = gpr3;
   //op->_data_re      = 0;
@@ -372,5 +372,5 @@
 
     // Result
-    op->_timing       = param->_timing[op->_operation];
+    op->_timing       = param->_timing[op->_type][op->_operation];
     op->_data_rd      = gpr3;
   //op->_data_re      = 0;
@@ -392,5 +392,5 @@
 
     // Result
-    op->_timing       = param->_timing[op->_operation];
+    op->_timing       = param->_timing[op->_type][op->_operation];
     op->_data_rd      = (index==param->_size_data)?0:(index+1);
   //op->_data_re      = 0;
@@ -412,5 +412,5 @@
 
     // Result
-    op->_timing       = param->_timing[op->_operation];
+    op->_timing       = param->_timing[op->_type][op->_operation];
     op->_data_rd      = index;
   //op->_data_re      = 0;
@@ -432,5 +432,5 @@
 
     // Result
-    op->_timing       = param->_timing[op->_operation];
+    op->_timing       = param->_timing[op->_type][op->_operation];
   //op->_data_rd      = 0;
     op->_data_re      = set_flag(op->_data_re,FLAG_F,f_out);
@@ -452,5 +452,5 @@
 
     // Result
-    op->_timing       = param->_timing[op->_operation];
+    op->_timing       = param->_timing[op->_type][op->_operation];
   //op->_data_rd      = 0;
     op->_data_re      = set_flag(op->_data_re,FLAG_F,f_out);
@@ -472,5 +472,5 @@
 
     // Result
-    op->_timing       = param->_timing[op->_operation];
+    op->_timing       = param->_timing[op->_type][op->_operation];
   //op->_data_rd      = 0;
     op->_data_re      = set_flag(op->_data_re,FLAG_F,f_out);
@@ -492,5 +492,5 @@
 
     // Result
-    op->_timing       = param->_timing[op->_operation];
+    op->_timing       = param->_timing[op->_type][op->_operation];
   //op->_data_rd      = 0;
     op->_data_re      = set_flag(op->_data_re,FLAG_F,f_out);
@@ -512,5 +512,5 @@
 
     // Result
-    op->_timing       = param->_timing[op->_operation];
+    op->_timing       = param->_timing[op->_type][op->_operation];
   //op->_data_rd      = 0;
     op->_data_re      = set_flag(op->_data_re,FLAG_F,f_out);
@@ -532,5 +532,5 @@
 
     // Result
-    op->_timing       = param->_timing[op->_operation];
+    op->_timing       = param->_timing[op->_type][op->_operation];
   //op->_data_rd      = 0;
     op->_data_re      = set_flag(op->_data_re,FLAG_F,f_out);
@@ -566,5 +566,5 @@
 
     // Result
-    op->_timing       = param->_timing[op->_operation];
+    op->_timing       = param->_timing[op->_type][op->_operation];
   //op->_data_rd      = 0;
     op->_data_re      = set_flag(op->_data_re,FLAG_F,f_out);
@@ -593,5 +593,5 @@
 
     // Result
-    op->_timing       = param->_timing[op->_operation];
+    op->_timing       = param->_timing[op->_type][op->_operation];
   //op->_data_rd      = 0;
     op->_data_re      = set_flag(op->_data_re,FLAG_F,f_out);
@@ -620,5 +620,5 @@
     
     // Result
-    op->_timing       = param->_timing[op->_operation];
+    op->_timing       = param->_timing[op->_type][op->_operation];
   //op->_data_rd      = 0;
     op->_data_re      = set_flag(op->_data_re,FLAG_F,f_out);
@@ -647,5 +647,5 @@
 
     // Result
-    op->_timing       = param->_timing[op->_operation];
+    op->_timing       = param->_timing[op->_type][op->_operation];
   //op->_data_rd      = 0;
     op->_data_re      = set_flag(op->_data_re,FLAG_F,f_out);
@@ -698,5 +698,5 @@
     
     // Result
-    op->_timing       = param->_timing[op->_operation];
+    op->_timing       = param->_timing[op->_type][op->_operation];
     op->_data_rd      = gpr2; // data_rb
   //op->_data_re      = 0;
@@ -749,5 +749,5 @@
 
     // Result
-    op->_timing       = param->_timing[op->_operation];
+    op->_timing       = param->_timing[op->_type][op->_operation];
     op->_write_rd     = (exception == EXCEPTION_ALU_NONE);
     op->_data_rd      = gpr2; // spr
@@ -770,5 +770,5 @@
 
     // Result
-    op->_timing       = param->_timing[op->_operation];
+    op->_timing       = param->_timing[op->_type][op->_operation];
     op->_data_rd      = gpr;
   //op->_data_re      = 0;
@@ -794,5 +794,5 @@
     
     // Result
-    op->_timing       = param->_timing[op->_operation];
+    op->_timing       = param->_timing[op->_type][op->_operation];
   //op->_data_rd      = 0;
   //op->_data_re      = 0;
@@ -818,5 +818,5 @@
     
     // Result
-    op->_timing       = param->_timing[op->_operation];
+    op->_timing       = param->_timing[op->_type][op->_operation];
   //op->_data_rd      = 0;
   //op->_data_re      = 0;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Parameters.cpp	(revision 75)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Parameters.cpp	(revision 76)
@@ -30,5 +30,5 @@
 			  uint32_t           nb_operation       ,
 			  uint32_t           nb_type            ,
-			  execute_timing_t * timing             ,
+			  execute_timing_t** timing             ,
 			  morpheo::behavioural::custom::custom_information_t (*get_custom_information) (uint32_t)) :
     _nb_context              (nb_context            ),
@@ -42,5 +42,4 @@
     _nb_operation            (nb_operation          ),
     _nb_type                 (nb_type               ),
-    _timing                  (timing                ),
     
     _size_context_id         (log2(nb_context      )),
@@ -58,13 +57,15 @@
     _have_port_packet_id     (_size_packet_id     > 0),
 
-    _have_groupe_MAC         ( (_timing[OPERATION_ALU_L_MAC  ]._latence > 0) or
-			       (_timing[OPERATION_ALU_L_MACRC]._latence > 0) or
-			       (_timing[OPERATION_ALU_L_MSB  ]._latence > 0))
+    _have_groupe_MAC         ( (timing[TYPE_SPECIAL][OPERATION_SPECIAL_L_MAC  ]._latence > 0) or
+			       (timing[TYPE_SPECIAL][OPERATION_SPECIAL_L_MACRC]._latence > 0) or
+			       (timing[TYPE_SPECIAL][OPERATION_SPECIAL_L_MSB  ]._latence > 0))
   {
     log_printf(FUNC,Functionnal_unit,FUNCTION,"Begin");
 
+    _timing                 = timing;
     _get_custom_information = get_custom_information;
 
     test();
+
     log_printf(FUNC,Functionnal_unit,FUNCTION,"End");
   };
@@ -83,5 +84,4 @@
     _nb_operation            (param._nb_operation           ),
     _nb_type                 (param._nb_type                ),
-    _timing                  (param._timing                 ),
 
     _size_context_id         (param._size_context_id        ),
@@ -103,4 +103,5 @@
     log_printf(FUNC,Functionnal_unit,FUNCTION,"Begin");
 
+    _timing                 = param._timing;
     _get_custom_information = param._get_custom_information;
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Parameters_msg_error.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Parameters_msg_error.cpp	(revision 75)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Parameters_msg_error.cpp	(revision 76)
@@ -28,11 +28,12 @@
     std::string msg = "";
 
-    for (uint32_t i=0; i<MAX_OPERATION; i++)
-      if (_timing->_delay != _timing->_latence)
-	msg = "  - For the operation '"+toString(i)+"', the delay and the latence must be equal.";
+    for (uint32_t i=0; i<MAX_TYPE; i++)
+      for (uint32_t j=0; j<MAX_OPERATION; j++)
+	if (_timing[i][j]._delay != _timing[i][j]._latence)
+	  msg = "  - For the type '"+toString(i)+"', and the operation '"+toString(j)+"', the delay and the latence must be equal.";
 
-    if (_have_groupe_MAC and ((_timing[OPERATION_ALU_L_MAC  ]._latence == 0) or
-			      (_timing[OPERATION_ALU_L_MACRC]._latence == 0) or
-			      (_timing[OPERATION_ALU_L_MSB  ]._latence == 0)))
+    if (_have_groupe_MAC and ((_timing[TYPE_SPECIAL][OPERATION_SPECIAL_L_MAC  ]._latence == 0) or
+			      (_timing[TYPE_SPECIAL][OPERATION_SPECIAL_L_MACRC]._latence == 0) or
+			      (_timing[TYPE_SPECIAL][OPERATION_SPECIAL_L_MSB  ]._latence == 0)))
       msg = "  - The functionnal unit implement a MAC unit, the latence to operation OPERATION_ALU_L_MAC, OPERATION_ALU_L_MACRC and OPERATION_ALU_L_MSB must be higher than 0.";
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/include/Load_store_unit.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/include/Load_store_unit.h	(revision 75)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/include/Load_store_unit.h	(revision 76)
@@ -96,6 +96,7 @@
   public    : SC_IN (Tpacket_t         )    *  in_MEMORY_IN_PACKET_ID   ;
   public    : SC_IN (Toperation_t      )    *  in_MEMORY_IN_OPERATION   ;
+//public    : SC_IN (Ttype_t           )    *  in_MEMORY_IN_TYPE        ;
   public    : SC_IN (Tlsq_ptr_t        )    *  in_MEMORY_IN_STORE_QUEUE_PTR_WRITE;
-  public    : SC_IN (Tlsq_ptr_t        )    *  in_MEMORY_IN_LOAD_QUEUE_PTR_WRITE;
+  public    : SC_IN (Tlsq_ptr_t        )    *  in_MEMORY_IN_LOAD_QUEUE_PTR_WRITE ;
 //public    : SC_IN (Tcontrol_t        )    *  in_MEMORY_IN_HAS_IMMEDIAT;
   public    : SC_IN (Tgeneral_data_t   )    *  in_MEMORY_IN_IMMEDIAT    ; // memory address
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Makefile
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Makefile	(revision 76)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Makefile	(revision 76)
@@ -0,0 +1,24 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+#-----[ Directory ]----------------------------------------
+DIR_COMPONENT			= ./
+include				$(DIR_COMPONENT)/Makefile.defs
+
+#-----[ Library ]------------------------------------------
+LIBRARY				= $(DIR_LIB)/libRead_unit.a
+
+
+#-----[ include ]------------------------------------------
+
+all				:
+				@$(MAKE) all_component
+
+include                         $(DIR_MORPHEO)/Behavioural/Makefile.flags
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Common
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Component
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Makefile.defs
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Makefile.defs	(revision 76)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Makefile.defs	(revision 76)
@@ -0,0 +1,11 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+#-----[ Directory ]----------------------------------------
+DIR_COMPONENT_MORPHEO		= ../../../../../..
+DIR_MORPHEO			= $(DIR_COMPONENT)/$(DIR_COMPONENT_MORPHEO)
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Makefile.deps
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Makefile.deps	(revision 76)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Makefile.deps	(revision 76)
@@ -0,0 +1,56 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+# DIR_MORPHEO must be defined
+
+Read_unit			= yes
+
+ifndef Behavioural
+include 			$(DIR_MORPHEO)/Behavioural/Makefile.deps
+endif
+ifndef Read_queue
+include				$(DIR_MORPHEO)/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/Makefile.deps
+endif
+ifndef Reservation_station
+include				$(DIR_MORPHEO)/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/Makefile.deps
+endif
+
+#-----[ Directory ]----------------------------------------
+
+Read_unit_DIR			=	$(DIR_MORPHEO)/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit
+
+#-----[ Library ]------------------------------------------
+Read_unit_LIBRARY		= 	-lRead_unit			\
+					$(Behavioural_LIBRARY)		\
+					$(Read_queue_LIBRARY)		\
+					$(Reservation_station_LIBRARY)
+
+Read_unit_DIR_LIBRARY		=	-L$(Read_unit_DIR)/lib		\
+					$(Behavioural_DIR_LIBRARY)	\
+					$(Read_queue_DIR_LIBRARY)	\
+					$(Reservation_station_DIR_LIBRARY)
+
+Read_unit_DEPENDENCIES		=	Behavioural_library		\
+					Read_queue_library		\
+					Reservation_station_library
+
+Read_unit_CLEAN	        	=	Behavioural_library_clean	\
+					Read_queue_library_clean	\
+					Reservation_station_library_clean
+
+#-----[ Rules ]--------------------------------------------
+
+.NOTPARALLEL			: Read_unit_library
+.NOTPARALLEL			: Read_unit_library_clean
+
+Read_unit_library		: $(Read_unit_DEPENDENCIES)
+				@\
+				$(MAKE) --directory=$(Read_unit_DIR) --makefile=Makefile;
+
+Read_unit_library_clean		: $(Read_unit_CLEAN)
+				@\
+				$(MAKE) --directory=$(Read_unit_DIR) --makefile=Makefile clean;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/config0.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/config0.cfg	(revision 75)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/config0.cfg	(revision 76)
@@ -13,2 +13,4 @@
 4	4	*2	# nb_gpr_write
 2	2	*2	# nb_spr_write
+4	4	*2	# size_store_queue
+4	4	*2	# size_load_queue    
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/config1.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/config1.cfg	(revision 75)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/config1.cfg	(revision 76)
@@ -13,2 +13,4 @@
 2	4	*2	# nb_gpr_write
 2	4	*2	# nb_spr_write
+4	4	*2	# size_store_queue
+4	4	*2	# size_load_queue    
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/config2.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/config2.cfg	(revision 75)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/config2.cfg	(revision 76)
@@ -13,2 +13,4 @@
 1	1	*2	# nb_gpr_write
 1	1	*2	# nb_spr_write
+4	4	*2	# size_store_queue
+4	4	*2	# size_load_queue    
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/config_min.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/config_min.cfg	(revision 75)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/config_min.cfg	(revision 76)
@@ -13,2 +13,4 @@
 1 	1 	*2	# nb_gpr_write
 1 	1 	*2	# nb_spr_write
+4	4	*2	# size_store_queue
+4	4	*2	# size_load_queue    
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/src/main.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/src/main.cpp	(revision 75)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/src/main.cpp	(revision 76)
@@ -8,5 +8,5 @@
 #include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/include/test.h"
 
-#define NB_PARAMS 13
+#define NB_PARAMS 15
 
 void usage (int argc, char * argv[])
@@ -27,4 +27,6 @@
        << " - nb_gpr_write        (unsigned int)" << endl
        << " - nb_spr_write        (unsigned int)" << endl
+       << " - size_store_queue    (unsigned int)" << endl
+       << " - size_load_queue     (unsigned int)" << endl
        << "" << endl;
 
@@ -60,4 +62,6 @@
   const uint32_t nb_gpr_write        = atoi(argv[x++]);
   const uint32_t nb_spr_write        = atoi(argv[x++]);
+  const uint32_t size_store_queue    = atoi(argv[x++]);
+  const uint32_t size_load_queue     = atoi(argv[x++]);
 
   try 
@@ -77,4 +81,6 @@
 	 ,nb_gpr_write
 	 ,nb_spr_write
+	 ,size_store_queue
+	 ,size_load_queue 
 	  );
       
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/src/test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/src/test.cpp	(revision 75)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/src/test.cpp	(revision 76)
@@ -75,4 +75,6 @@
   sc_signal<Toperation_t       >         * READ_QUEUE_IN_OPERATION    = new sc_signal<Toperation_t       >         ("READ_QUEUE_IN_OPERATION   ");
   sc_signal<Ttype_t            >         * READ_QUEUE_IN_TYPE         = new sc_signal<Ttype_t            >         ("READ_QUEUE_IN_TYPE        ");
+  sc_signal<Tlsq_ptr_t         >         * READ_QUEUE_IN_STORE_QUEUE_PTR_WRITE = new sc_signal<Tlsq_ptr_t>         ("READ_QUEUE_IN_STORE_QUEUE_PTR_WRITE");
+  sc_signal<Tlsq_ptr_t         >         * READ_QUEUE_IN_LOAD_QUEUE_PTR_WRITE  = new sc_signal<Tlsq_ptr_t>         ("READ_QUEUE_IN_LOAD_QUEUE_PTR_WRITE ");
   sc_signal<Tcontrol_t         >         * READ_QUEUE_IN_HAS_IMMEDIAT = new sc_signal<Tcontrol_t         >         ("READ_QUEUE_IN_HAS_IMMEDIAT");
   sc_signal<Tgeneral_data_t    >         * READ_QUEUE_IN_IMMEDIAT     = new sc_signal<Tgeneral_data_t    >         ("READ_QUEUE_IN_IMMEDIAT    ");
@@ -98,4 +100,6 @@
   sc_signal<Toperation_t       >         * READ_QUEUE_OUT_OPERATION   = new sc_signal<Toperation_t       >         ("READ_QUEUE_OUT_OPERATION   ");
   sc_signal<Ttype_t            >         * READ_QUEUE_OUT_TYPE        = new sc_signal<Ttype_t            >         ("READ_QUEUE_OUT_TYPE        ");
+  sc_signal<Tlsq_ptr_t         >         * READ_QUEUE_OUT_STORE_QUEUE_PTR_WRITE = new sc_signal<Tlsq_ptr_t>        ("READ_QUEUE_OUT_STORE_QUEUE_PTR_WRITE");
+  sc_signal<Tlsq_ptr_t         >         * READ_QUEUE_OUT_LOAD_QUEUE_PTR_WRITE  = new sc_signal<Tlsq_ptr_t>        ("READ_QUEUE_OUT_LOAD_QUEUE_PTR_WRITE ");
   sc_signal<Tcontrol_t         >         * READ_QUEUE_OUT_HAS_IMMEDIAT= new sc_signal<Tcontrol_t         >         ("READ_QUEUE_OUT_HAS_IMMEDIAT");
   sc_signal<Tgeneral_data_t    >         * READ_QUEUE_OUT_IMMEDIAT    = new sc_signal<Tgeneral_data_t    >         ("READ_QUEUE_OUT_IMMEDIAT    ");
@@ -226,4 +230,6 @@
   (*(_Read_queue-> in_READ_QUEUE_IN_OPERATION      )) (*(READ_QUEUE_IN_OPERATION      ));
   (*(_Read_queue-> in_READ_QUEUE_IN_TYPE           )) (*(READ_QUEUE_IN_TYPE           ));
+  (*(_Read_queue-> in_READ_QUEUE_IN_STORE_QUEUE_PTR_WRITE)) (*(READ_QUEUE_IN_STORE_QUEUE_PTR_WRITE));
+  (*(_Read_queue-> in_READ_QUEUE_IN_LOAD_QUEUE_PTR_WRITE )) (*(READ_QUEUE_IN_LOAD_QUEUE_PTR_WRITE ));
   (*(_Read_queue-> in_READ_QUEUE_IN_HAS_IMMEDIAT   )) (*(READ_QUEUE_IN_HAS_IMMEDIAT   ));
   (*(_Read_queue-> in_READ_QUEUE_IN_IMMEDIAT       )) (*(READ_QUEUE_IN_IMMEDIAT       ));
@@ -251,15 +257,17 @@
   (*(_Read_queue->out_READ_QUEUE_OUT_OPERATION     )) (*(READ_QUEUE_OUT_OPERATION     )); 
   (*(_Read_queue->out_READ_QUEUE_OUT_TYPE          )) (*(READ_QUEUE_OUT_TYPE          )); 
+  (*(_Read_queue->out_READ_QUEUE_OUT_STORE_QUEUE_PTR_WRITE)) (*(READ_QUEUE_OUT_STORE_QUEUE_PTR_WRITE)); 
+  (*(_Read_queue->out_READ_QUEUE_OUT_LOAD_QUEUE_PTR_WRITE )) (*(READ_QUEUE_OUT_LOAD_QUEUE_PTR_WRITE )); 
   (*(_Read_queue->out_READ_QUEUE_OUT_HAS_IMMEDIAT  )) (*(READ_QUEUE_OUT_HAS_IMMEDIAT  )); 
   (*(_Read_queue->out_READ_QUEUE_OUT_IMMEDIAT      )) (*(READ_QUEUE_OUT_IMMEDIAT      )); 
-  (*(_Read_queue->out_READ_QUEUE_OUT_READ_RA       )) (*(READ_QUEUE_OUT_READ_RA       )); 
+//   (*(_Read_queue->out_READ_QUEUE_OUT_READ_RA       )) (*(READ_QUEUE_OUT_READ_RA       )); 
   (*(_Read_queue->out_READ_QUEUE_OUT_NUM_REG_RA    )) (*(READ_QUEUE_OUT_NUM_REG_RA    )); 
   (*(_Read_queue->out_READ_QUEUE_OUT_DATA_RA_VAL   )) (*(READ_QUEUE_OUT_DATA_RA_VAL   )); 
   (*(_Read_queue->out_READ_QUEUE_OUT_DATA_RA       )) (*(READ_QUEUE_OUT_DATA_RA       )); 
-  (*(_Read_queue->out_READ_QUEUE_OUT_READ_RB       )) (*(READ_QUEUE_OUT_READ_RB       )); 
+//   (*(_Read_queue->out_READ_QUEUE_OUT_READ_RB       )) (*(READ_QUEUE_OUT_READ_RB       )); 
   (*(_Read_queue->out_READ_QUEUE_OUT_NUM_REG_RB    )) (*(READ_QUEUE_OUT_NUM_REG_RB    )); 
   (*(_Read_queue->out_READ_QUEUE_OUT_DATA_RB_VAL   )) (*(READ_QUEUE_OUT_DATA_RB_VAL   )); 
   (*(_Read_queue->out_READ_QUEUE_OUT_DATA_RB       )) (*(READ_QUEUE_OUT_DATA_RB       )); 
-  (*(_Read_queue->out_READ_QUEUE_OUT_READ_RC       )) (*(READ_QUEUE_OUT_READ_RC       )); 
+//   (*(_Read_queue->out_READ_QUEUE_OUT_READ_RC       )) (*(READ_QUEUE_OUT_READ_RC       )); 
   (*(_Read_queue->out_READ_QUEUE_OUT_NUM_REG_RC    )) (*(READ_QUEUE_OUT_NUM_REG_RC    )); 
   (*(_Read_queue->out_READ_QUEUE_OUT_DATA_RC_VAL   )) (*(READ_QUEUE_OUT_DATA_RC_VAL   )); 
@@ -408,4 +416,6 @@
 	      READ_QUEUE_IN_OPERATION   ->write(0);
 	      READ_QUEUE_IN_TYPE        ->write(0);
+	      READ_QUEUE_IN_STORE_QUEUE_PTR_WRITE->write(0);
+	      READ_QUEUE_IN_LOAD_QUEUE_PTR_WRITE ->write(0);
 	      READ_QUEUE_IN_HAS_IMMEDIAT->write(0);
 	      READ_QUEUE_IN_IMMEDIAT    ->write(0);
@@ -535,20 +545,20 @@
 		TEST(Tcontext_t        ,READ_QUEUE_OUT_FRONT_END_ID  ->read(),(3*ctxt)%_param->_nb_front_end);
 
-	      TEST(Tcontrol_t        ,READ_QUEUE_OUT_READ_RA    ->read(),_read_ra      [rob_id]);
+// 	      TEST(Tcontrol_t        ,READ_QUEUE_OUT_READ_RA    ->read(),_read_ra      [rob_id]);
 	      TEST(Tgeneral_address_t,READ_QUEUE_OUT_NUM_REG_RA ->read(),_num_reg_ra   [rob_id]);
-	      TEST(Tcontrol_t        ,READ_QUEUE_OUT_DATA_RA_VAL->read(),not READ_QUEUE_OUT_READ_RA->read() or _gpr_val [_num_reg_ra[rob_id]][ctxt]);
-	      if (READ_QUEUE_OUT_READ_RA    ->read() and
+	      TEST(Tcontrol_t        ,READ_QUEUE_OUT_DATA_RA_VAL->read(),not _read_ra [rob_id] or _gpr_val [_num_reg_ra[rob_id]][ctxt]);
+	      if (_read_ra [rob_id] and
 		  READ_QUEUE_OUT_DATA_RA_VAL->read())
 	      TEST(Tgeneral_data_t   ,READ_QUEUE_OUT_DATA_RA    ->read(),_gpr          [_num_reg_ra[rob_id]][ctxt]);
-	      TEST(Tcontrol_t        ,READ_QUEUE_OUT_READ_RB    ->read(),_read_rb      [rob_id]);
+// 	      TEST(Tcontrol_t        ,READ_QUEUE_OUT_READ_RB    ->read(),_read_rb      [rob_id]);
 	      TEST(Tgeneral_address_t,READ_QUEUE_OUT_NUM_REG_RB ->read(),_num_reg_rb   [rob_id]);
-	      TEST(Tcontrol_t        ,READ_QUEUE_OUT_DATA_RB_VAL->read(),not READ_QUEUE_OUT_READ_RB->read() or _gpr_val [_num_reg_rb[rob_id]][ctxt]);
-	      if (READ_QUEUE_OUT_READ_RB    ->read() and
+	      TEST(Tcontrol_t        ,READ_QUEUE_OUT_DATA_RB_VAL->read(),not _read_rb [rob_id] or _gpr_val [_num_reg_rb[rob_id]][ctxt]);
+	      if (_read_rb [rob_id] and
 		  READ_QUEUE_OUT_DATA_RB_VAL->read())
 	      TEST(Tgeneral_data_t   ,READ_QUEUE_OUT_DATA_RB    ->read(),_gpr          [_num_reg_rb[rob_id]][ctxt]);
-	      TEST(Tcontrol_t        ,READ_QUEUE_OUT_READ_RC    ->read(),_read_rc      [rob_id]);
+// 	      TEST(Tcontrol_t        ,READ_QUEUE_OUT_READ_RC    ->read(),_read_rc      [rob_id]);
 	      TEST(Tspecial_address_t,READ_QUEUE_OUT_NUM_REG_RC ->read(),_num_reg_rc   [rob_id]);
-      	      TEST(Tcontrol_t        ,READ_QUEUE_OUT_DATA_RC_VAL->read(),not READ_QUEUE_OUT_READ_RC->read() or _spr_val [_num_reg_rc[rob_id]][ctxt]);
-	      if (READ_QUEUE_OUT_READ_RC    ->read() and
+      	      TEST(Tcontrol_t        ,READ_QUEUE_OUT_DATA_RC_VAL->read(),not _read_rc [rob_id] or _spr_val [_num_reg_rc[rob_id]][ctxt]);
+	      if (_read_rc [rob_id] and
 		  READ_QUEUE_OUT_DATA_RC_VAL->read())
 	      TEST(Tspecial_data_t   ,READ_QUEUE_OUT_DATA_RC    ->read(),_spr     [_num_reg_rc[rob_id]][ctxt]);
@@ -581,4 +591,6 @@
    delete    READ_QUEUE_IN_OPERATION    ;
    delete    READ_QUEUE_IN_TYPE         ;
+   delete    READ_QUEUE_IN_STORE_QUEUE_PTR_WRITE;
+   delete    READ_QUEUE_IN_LOAD_QUEUE_PTR_WRITE ;
    delete    READ_QUEUE_IN_HAS_IMMEDIAT ;
    delete    READ_QUEUE_IN_IMMEDIAT     ;
@@ -606,4 +618,6 @@
    delete    READ_QUEUE_OUT_OPERATION   ;
    delete    READ_QUEUE_OUT_TYPE        ;
+   delete    READ_QUEUE_OUT_STORE_QUEUE_PTR_WRITE;
+   delete    READ_QUEUE_OUT_LOAD_QUEUE_PTR_WRITE ;
    delete    READ_QUEUE_OUT_HAS_IMMEDIAT;
    delete    READ_QUEUE_OUT_IMMEDIAT    ;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/include/Parameters.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/include/Parameters.h	(revision 75)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/include/Parameters.h	(revision 76)
@@ -41,4 +41,6 @@
   public : const uint32_t    _nb_gpr_write         ;
   public : const uint32_t    _nb_spr_write         ;
+  public : const uint32_t    _size_store_queue     ;
+  public : const uint32_t    _size_load_queue      ;
 
   public : const uint32_t    _nb_gpr_read          ;
@@ -73,5 +75,8 @@
 			uint32_t nb_type            ,
 			uint32_t nb_gpr_write       ,
-			uint32_t nb_spr_write       );
+			uint32_t nb_spr_write       ,
+			uint32_t size_store_queue   ,
+			uint32_t size_load_queue    );
+
   public : Parameters  (Parameters & param) ;
   public : ~Parameters () ;
